#ifndef _FILECAVECAM
#define _FILECAVECAM

/*
 *
 * This is part of the ANL/MCS/FL CAVEav distribution.
 * written by Ivan R. Judson
 *
 */

#include <GL/gl.h>
#include <GL/glu.h>
#include <stdio.h>
#include <stdlib.h>

#include "CAVcam.h"

#if defined(__sgi)
#include <unistd.h>
#include <signal.h>
#endif

/** This is the derived class fileCAVEcam. fileCAVcam takes the frames
    stored for output and writes them out to individually numbered rgb
    format files. 
*/

class fileCAVcam : public CAVcam {

public:
  /**@name  Methods */
  //@{

  /// Constructor, which included optional arguments for output filename(and path), width, height and depth

  fileCAVcam(char *fn = "CCFrame", 
	      int width = 640, int height = 480, int depth = 3, 
	      float ex = 0.0, float ey = 5.0, float ez = 0.0, 
	      float cx = 0.0, float cy = 5.0, float cz = -5.0,
	      float ux = 0.0, float uy = 1.0, float uz = 0.0);

  /// Destructor

  ~fileCAVcam();

  /// Overridden function to write the frames to the sequence of files

  void PutPix();

  /// Overridden function to start capture
	
  void Init();

  //@}

private:

  /**@name  Data */
  //@{

  /// File basename

  char *fnbase;

  //@}
};

#endif
